
import SoaG.*;
import SoaG.AdabasEmployeesMiniServiceStub.*;

/*
 *   The SOA Gateway GET method will return a single record,
 *   the Adabas ISN will be used to indicate the record we are looking for. 
 */

public class Tut_01b_GetByISN {

  public static void main(String[] args) {

    try {
	  AdabasEmployeesMiniServiceStub stub = new AdabasEmployeesMiniServiceStub();
	  
	  /*
	   *   In order to get a Record by ISN it has to be specified in the 
	   *   SOAP header as follows: 
	   */
	  AdabasEmployeeHeader hdr = new AdabasEmployeesMiniServiceStub.AdabasEmployeeHeader();
	  hdr.setVersion(1);	// This is required
	  hdr.setSOAGateway_Internal_Adabas_ISN("173");

	  /*
	   *   When GETting by ISN don't specify a key, but the respective property 
	   *   will have to be present nevertheless, otherwise Axis2 will object.
	   */
	  AdabasEmployeePrimaryKeyType pk = new AdabasEmployeePrimaryKeyType();
	  pk.setPersonnel_id("");
	  	  
	  AdabasEmployeeGetElement getEle = new AdabasEmployeeGetElement();
	  getEle.setAdabasEmployeeGetElement(pk);
	  
	  AdabasEmployeesMiniElement result = null;
	  
	  result = stub.get(getEle, null, hdr);
	  
	  AdabasEmployeesMiniElementType root = result.getAdabasEmployeesMiniElement();
	  AdabasEmployeesMiniType group = root.getAdabasEmployeesMini();
	  AdabasEmployeeType elements[] = group.getAdabasEmployee();
	  
	  AdabasEmployeeType r = elements[0];
	  String     address[] = r.getAddress_line();
      System.out.println("This is the employee record with ISN 173:\n\n"
    		  	       + r.getPersonnel_id() + ", "
		               + r.getName() + ", "
			           + r.getFirst_name() + ", "
			           + r.getCity() + ", "
			           + address[0]
			           );
	  
    } catch (Exception ex) {
	  ex.printStackTrace();
    }
  }

}
