import SoaG.*;
import SoaG.AdabasEmployeesMiniServiceStub.*;

/*
 *   This tutorial returns a number of Employees records SELECTed
 *   by a range of Personnel IDs.
 *   
 *   In contrast to the LIST method SELECT allows for the specification
 *   of complex search criteria, including AND and OR conditions.
 *   
 *   Please consult the SOA Gateway documentation for more information.
 */
public class Tut_03a_SelectSimple {

	public static void main(String[] args) {

	    try {
		  AdabasEmployeesMiniServiceStub stub = new AdabasEmployeesMiniServiceStub();

		  AdabasEmployeeSelectCountElement sce = new AdabasEmployeesMiniServiceStub.AdabasEmployeeSelectCountElement();
		  
		  AdabasEmployeeSelectType selType = new AdabasEmployeesMiniServiceStub.AdabasEmployeeSelectType();
		  
		  Condition_type0 cond1 = new Condition_type0();
		  
		  Personnel_id_type0 pidFrom = new Personnel_id_type0();
		  pidFrom.setCondition(ConditionType.GE);
		  pidFrom.setString("50005000");
		  cond1.addPersonnel_id(pidFrom);
		  
		  Personnel_id_type0 pidTo = new Personnel_id_type0();
		  pidTo.setCondition(ConditionType.LE);
		  pidTo.setString("50009999");
		  cond1.addPersonnel_id(pidTo);
		  
		  selType.addCondition(cond1);
		  
		  sce.setAdabasEmployeeSelectCountElement(selType);
		  
		  SelectCountResult scResult = null;
		  
		  scResult = stub.selectCount(sce, null, null);
		  
		  System.out.println(scResult.getTotalCount() + " records in range (50005000,50009999):\n");
		  
		  AdabasEmployeeSelectElement ese = new AdabasEmployeesMiniServiceStub.AdabasEmployeeSelectElement();
		  ese.setAdabasEmployeeSelectElement(selType);
		  
		  AdabasEmployeesMiniElement selResult = null;
		  
		  selResult = stub.select(ese, null, null);
		  
		  AdabasEmployeesMiniElementType selResType = selResult.getAdabasEmployeesMiniElement();
		  AdabasEmployeesMiniType selResMiniType = selResType.getAdabasEmployeesMini();
		  AdabasEmployeeType empls[] = selResMiniType.getAdabasEmployee();
		  
		  for (int i = 0; i < empls.length; i++) {
			  AdabasEmployeeType r = empls[i];
			  System.out.println("[" + i + "] = " 
					           + r.getPersonnel_id() + ", "
					           + r.getName() + ", "
					           + r.getFirst_name() + ", "
					           + r.getCity());
		  }
		    
	    } catch (Exception ex) {
		  ex.printStackTrace();
	    }
	  }

}
