import SoaG.*;
import SoaG.AdabasEmployeesMiniServiceStub.*;

/*
 *   This tutorial SELECTs a number of Employees records by Personnel ID
 *   and asks the SOA Gateway to have them returned sorted by Name 
 */
public class Tut_03b_SelectSorted {

	public static void main(String[] args) {

	    try {
		  AdabasEmployeesMiniServiceStub stub = new AdabasEmployeesMiniServiceStub();

		  AdabasEmployeeSelectType selType = new AdabasEmployeesMiniServiceStub.AdabasEmployeeSelectType();
		  
		  Condition_type0 cond1 = new Condition_type0();
		  
		  Personnel_id_type0 pidFrom = new Personnel_id_type0();
		  pidFrom.setCondition(ConditionType.GE);
		  pidFrom.setString("50005000");
		  cond1.addPersonnel_id(pidFrom);
		  
		  Personnel_id_type0 pidTo = new Personnel_id_type0();
		  pidTo.setCondition(ConditionType.LE);
		  pidTo.setString("50009999");
		  cond1.addPersonnel_id(pidTo);
		  
		  selType.addCondition(cond1);
		  
		  AdabasEmployeeSelectElement ese = new AdabasEmployeesMiniServiceStub.AdabasEmployeeSelectElement();
		  ese.setAdabasEmployeeSelectElement(selType);

		  AdabasEmployeeHeader hdr = new AdabasEmployeesMiniServiceStub.AdabasEmployeeHeader();
		  hdr.setVersion(1);	// This is required
		  hdr.setSOAGateway_Internal_Adabas_Sort_Order("name");
		  
		  AdabasEmployeesMiniElement selResult = null;
		  
		  selResult = stub.select(ese, null, hdr);
		  
		  AdabasEmployeesMiniElementType selResType = selResult.getAdabasEmployeesMiniElement();
		  AdabasEmployeesMiniType selResMiniType = selResType.getAdabasEmployeesMini();
		  AdabasEmployeeType empls[] = selResMiniType.getAdabasEmployee();
		  
		  for (int i = 0; i < empls.length; i++) {
			  AdabasEmployeeType r = empls[i];
			  System.out.println("[" + i + "] = " 
					           + r.getPersonnel_id() + ", "
					           + r.getName() + ", "
					           + r.getFirst_name() + ", "
					           + r.getCity());
		  }
		    
	    } catch (Exception ex) {
		  ex.printStackTrace();
	    }
	  }

}
