import SoaG.*;
import SoaG.AdabasEmployeesMiniServiceStub.*;

/*
 *   We are going to ADD a record first.
 *   
 *   No transaction is initiated so an implicit End-of-transaction (Commit)
 *   will be issued.
 *    
 */

public class Tut_04a_AddUpdateDelete {

  static AdabasEmployeesMiniServiceStub stub = null;
  static AdabasEmployeePrimaryKeyType     pk = null;
  static OperationResult               opRes = null;
  static AdabasEmployeeType         eTypes[] = null;
  static AdabasEmployeeType               et = null;
	
  public static void main(String[] args) {
  
    try {
      stub = new AdabasEmployeesMiniServiceStub();
      
	  /*
	   *   First add a record
	   */
	  AdabasEmployeesMiniAddElement addEle = new AdabasEmployeesMiniAddElement();
	  AdabasEmployeesMiniType      theType = new AdabasEmployeesMiniType();
	  AdabasEmployeeType        theDatas[] = new AdabasEmployeeType[1];
	  AdabasEmployeeType           theData = new AdabasEmployeeType();
	  
	  theData.setPersonnel_id("99998888");
	  theData.setName("Tester");
	  theData.setFirst_name("Thename");
	  theData.setCity("Anytown");
	  String address[] = {"Mystreet", "PO box 222"};
	  theData.setAddress_line(address);
	  
	  theDatas[0] = theData;
	  theType.setAdabasEmployee(theDatas);
	  addEle.setAdabasEmployeesMiniAddElement(theType);
	  	  
	  opRes = stub.add(addEle, null, null);
	  
	  String sRes = opRes.getResults();
	  if (sRes.compareTo("add successful") == 0) {
	    System.out.println(sRes);
	  }
	  
    } catch (Exception ex) {
      System.out.println("--- ADD failed ---");
	  ex.printStackTrace();
	  System.exit(-99);
    }
    
    /*
     *   GET the record just stored.
     */
    if (! (getTheRecord()) ) {
    	System.exit(-99);
    }
    
    /*
     *   Update some data
     */
    AdabasEmployeesMiniUpdateElement updEle = new AdabasEmployeesMiniUpdateElement();
    AdabasEmployeesMiniType updType = new AdabasEmployeesMiniType();
    
    /*
     *   Update data retrieved via GET
     *   
     *   Make sure the primary key (personnel_id in this case) is set.
     *   
     *   Also, all properties have to be set to at least an initial ("empty")
     *   value, Axis2 will throw nasty faults when null parameters are sent.
     */
    
    et.setCity("NewCity");
    
    updType.setAdabasEmployee(eTypes);
    updEle.setAdabasEmployeesMiniUpdateElement(updType);
    
    try {
      opRes = stub.update(updEle, null, null);
      
      String sRes = opRes.getResults();
      if (sRes.compareTo("update successful") == 0) {
    	System.out.println(sRes);
      }

    } catch (Exception ex) {
        System.out.println("--- UPDATE failed ---");
  	    ex.printStackTrace();
  	    System.exit(-99);
    }
    
    /*
     *   GET the record just updated.
     */
    if (! (getTheRecord()) ) {
    	System.exit(-99);
    }
    
    
    /*
     *        *   Finally DELETE the record
     */
    try {

      AdabasEmployeeDeleteElement delEle = new AdabasEmployeeDeleteElement();
      delEle.setAdabasEmployeeDeleteElement(pk);

      opRes = stub.delete(delEle, null, null);

      String sRes = opRes.getResults();
      if (sRes.compareTo("delete successful") == 0) {
    	System.out.println(sRes);
      }
    	  
    } catch (Exception ex) {
      System.out.println("--- DELETE failed ---");
      ex.printStackTrace();
    }

  }

  private static boolean getTheRecord() {
	  
    try {
  	  pk = new AdabasEmployeePrimaryKeyType();
  	  pk.setPersonnel_id("99998888");
  	  	  
  	  AdabasEmployeeGetElement getEle = new AdabasEmployeeGetElement();
  	  getEle.setAdabasEmployeeGetElement(pk);
  	  
  	  AdabasEmployeesMiniElement result = null;
  	  
  	  result = stub.get(getEle, null, null);
  	  
  	  AdabasEmployeesMiniElementType root = result.getAdabasEmployeesMiniElement();
  	  AdabasEmployeesMiniType group = root.getAdabasEmployeesMini();
  	  eTypes = group.getAdabasEmployee();
  	  
  	  et = eTypes[0];
      System.out.println("\n--- record read ---\n"
        			   + et.getPersonnel_id() + ", "
  		               + et.getName() + ", "
  			           + et.getFirst_name() + ", "
  			           + et.getCity()
  			           + "\n");
  	  
      } catch (Exception ex) {
        System.out.println("--- GET failed ---");
  	    ex.printStackTrace();
  	    return false;
      }

      return true;
  }
}
