package com.risaris.axis2.entirex.transports;

import java.net.URL;
import java.net.URLDecoder;
import java.util.HashMap;

import org.apache.axis2.AxisFault;
import org.apache.axis2.addressing.EndpointReference;
import org.apache.axis2.context.ConfigurationContext;
import org.apache.axis2.context.MessageContext;
import org.apache.axis2.description.TransportOutDescription;
import org.apache.axis2.handlers.AbstractHandler;
import org.apache.axis2.transport.TransportSender;

import com.softwareag.entirex.aci.Broker;
import com.softwareag.entirex.aci.BrokerService;
import com.softwareag.entirex.aci.BrokerMessage;
import com.softwareag.entirex.aci.BrokerException;
import com.softwareag.entirex.aci.ConversationState;
import com.softwareag.entirex.aci.UnitofWork;

import java.io.ByteArrayInputStream;
import java.io.InputStream;

public class ExxTransportReceiver extends AbstractHandler implements TransportSender
{
	private ConversationState convState;
	private String waitTime = "5S"; // default waittime for receive calls
	
	private BrokerService bService;
	
	public ExxTransportReceiver()
	{
		convState = null;
		bService = null;
	}
	
	public InvocationResponse invoke(MessageContext msgContext)
			throws AxisFault {
		
		//System.out.println("====== ExxTransportReceiver.invoke ====== ");

		try{

			/*EndpointReference epr = msgContext.getTo();
			URL endPointUrl = new URL( epr.getAddress() );
			
			HashMap hashMap = new HashMap();
			for (String param : endPointUrl.getQuery().split("&")) 
			{
				String pair[] = param.split("=");
	            hashMap.put( URLDecoder.decode(pair[0], "UTF-8"), URLDecoder.decode(pair[1], "UTF-8") );
			}
			
			// We get in something like "192.168.135.208:1971:TCP" and we need something like
			// "tcpip://meath"
			String brokerID = "tcpip://" + ((String)hashMap.get( "brokerID" )).split(":")[0];
			//System.out.println( "brokerID = " + brokerID);
			
			Broker broker = new Broker(brokerID, "JavaUser");
		
			broker.logon();

			// 	create the BrokerService object
			
			//System.out.println( "class = " + (String)hashMap.get( "class" ));
			//System.out.println( "server = " + (String)hashMap.get( "server" ));
			//System.out.println( "service = " + (String)hashMap.get( "inputService" ));
			//System.out.println( "service = " + (String)hashMap.get( "outputService" ));
			
			BrokerService bService = new BrokerService(broker, (String)hashMap.get("class"), (String)hashMap.get("server"), (String)hashMap.get("service") );
			bService.setMaxReceiveLen(10000000);
			bService.register();
			*/
			
			bService.setMaxReceiveLen(10000000);
			bService.register();
			
			UnitofWork uow = null;
			
			if( convState != null )
				uow = new UnitofWork( bService, convState );
			else
				uow = new UnitofWork( bService );
			
			String fullMsg = new String();
			
			BrokerMessage msg = uow.receive( waitTime );
			fullMsg = msg.toString();
			
			/*
			//System.out.println("Received : " + msg );
			String status = uow.getStatus();

			while( status != null && ( status.equals("RECV_LAST") == false && status.equals("RECV_ONLY") == false ) )
			{
				msg = uow.receive("2S");
				fullMsg = fullMsg + msg.toString();
				
				status = uow.getStatus();
				
				//System.out.println("Received : " + msg );
			}
			
			if( status != null ) */
				uow.commit();
			
			bService.deregisterImmediate();
			//broker.logoff();
			
			//System.out.println("Full msg " + fullMsg );
			InputStream is = new ByteArrayInputStream(fullMsg.getBytes("UTF-8"));
			
			msgContext.setProperty(MessageContext.TRANSPORT_IN, is);
			
		}
		catch( BrokerException be )
		{
			be.printStackTrace();
			throw new AxisFault("Broker Exception");
		}
		catch( Exception e )
		{
			e.printStackTrace();
		}
		
		return InvocationResponse.CONTINUE;
	}

	public void cleanup(MessageContext msgContext) throws AxisFault {
		// TODO Auto-generated method stub
		
	}

	public void init(ConfigurationContext confContext,
			TransportOutDescription transportOut) throws AxisFault {
		// TODO Auto-generated method stub
		throw new AxisFault("TEsTME");
		
	}

	public void stop() {
		// TODO Auto-generated method stub
		
	}
	
	public void setConvState( Object state )
	{
		convState = (ConversationState)state;
	}
	
	public void setService( Object service )
	{
		bService = (BrokerService)service;
	}

}
