package com.risaris.axis2.mq.transports;

import java.io.ByteArrayOutputStream;
import java.io.OutputStream;
import java.net.URL;
import java.net.URLDecoder;
import java.util.HashMap;

import org.apache.axis2.AxisFault;
import org.apache.axis2.addressing.EndpointReference;
import org.apache.axis2.context.ConfigurationContext;
import org.apache.axis2.context.MessageContext;
import org.apache.axis2.description.TransportOutDescription;
import org.apache.axis2.handlers.AbstractHandler;
import org.apache.axis2.transport.TransportSender;
import org.apache.axis2.transport.TransportUtils;

import com.ibm.mq.*;
import com.ibm.mq.constants.CMQC;

public class MQTransportSender extends AbstractHandler implements TransportSender
{

	private byte[] messageID;
	MQEnvironment thisEnv = null;

	public void setMQEnvironment( MQEnvironment env )
	{
		thisEnv = env;
	}

	public InvocationResponse invoke(MessageContext msgContext)
			throws AxisFault {
		
		System.out.println("====== MQTransportSender.invoke ====== ");

		try{
			
			EndpointReference epr = msgContext.getTo();
			URL endPointUrl = new URL( epr.getAddress() );
			
			HashMap hashMap = new HashMap();
			for (String param : endPointUrl.getQuery().split("&")) 
			{
				String pair[] = param.split("=");
	            hashMap.put( URLDecoder.decode(pair[0], "UTF-8"), URLDecoder.decode(pair[1], "UTF-8") );
			}
			
			if( thisEnv == null )
			{
				MQEnvironment.hostname = (String)hashMap.get("connection");
				MQEnvironment.channel  = (String)hashMap.get("channel");
			}
			
			MQQueueManager queueManager=new MQQueueManager( (String)hashMap.get("manager") );

			// Open a Q for input - note open with Shared access
			System.out.println("Using input Q " + (String)hashMap.get("inputQ") );
			
			MQQueue queue = queueManager.accessQueue( (String)hashMap.get("inputQ"), CMQC.MQOO_OUTPUT );
			
			// De-serialize into OutputStream
			OutputStream out = new ByteArrayOutputStream();
			TransportUtils.writeMessage(msgContext, out);
			
			MQMessage myMessage = new MQMessage();
			
			// *** TODO *** What am I doing here? It is to get around the MQRC_FORMAT_ERROR problem when SG does get 
			// Set message format to MQC.MQFMT_STRING for use without MQCIH header
			// NB. Change to 'MQCICS  ' if using header !!!
			myMessage.format = CMQC.MQFMT_STRING;
			
			myMessage.writeString( out.toString() );

			// Use the default put message options...
			MQPutMessageOptions pmo = new MQPutMessageOptions();

			// put the message!
			queue.put(myMessage,pmo);
			messageID = new byte[ myMessage.messageId.length ];
			messageID = myMessage.messageId.clone();
			queue.close();
			
			queueManager.disconnect();
			
		}
		catch( Exception e )
		{
			e.printStackTrace();
		}
		
		return InvocationResponse.CONTINUE;
	}

	public void cleanup(MessageContext msgContext) throws AxisFault {
		// TODO Auto-generated method stub
		
	}

	public void init(ConfigurationContext confContext,
			TransportOutDescription transportOut) throws AxisFault {
		// TODO Auto-generated method stub
		throw new AxisFault("TEsTME");
		
	}

	public void stop() {
		// TODO Auto-generated method stub
		
	}
	
	public byte[] getMessageID() {
		return messageID;
		
	}

}
